<template>
  <div class='register-wrapper' id='div_reg'>
    <el-form ref='registerForm' :model='registerForm' :rules='registerRules' class='register-form'>
      <el-row>
        <el-col :span='24'>
          <el-form-item prop='username'>
            <el-input v-model='registerForm.username' type='text' auto-complete='off' placeholder='用户名' >
              <el-select v-model='registerForm.role' slot='prepend' placeholder='身份'>
                <el-option label='学生' value='student'></el-option>
                <el-option label='教师' value='teacher'></el-option>
              </el-select>
              <i slot='prefix' class='el-input__icon el-icon-user-solid'></i>
            </el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-form-item prop='password'>
          <el-input v-model='registerForm.password' type='password' auto-complete='off' placeholder='密码' size='medium'>
            <svg-icon slot='prefix' icon-class='password' class='el-input__icon input-icon' />
          </el-input>
        </el-form-item>
      </el-row>
      <el-row>
        <el-form-item prop='password'>
          <el-input v-model='registerForm.password_again' type='password' auto-complete='off' placeholder='重复密码'>
            <svg-icon slot='prefix' icon-class='password' class='el-input__icon input-icon' />
          </el-input>
        </el-form-item>
      </el-row>
      <el-row>
        <el-form-item prop='email'>
          <el-input v-model='registerForm.email' type='text' auto-complete='off' placeholder='同济邮箱' size='medium'>
            <svg-icon slot='prefix' icon-class='email' class='el-input__icon input-icon' />
          </el-input>
        </el-form-item>
      </el-row>
      <el-row>
        <el-form-item>
          <button class='btn-register' @click.prevent='send_email()'>
            向邮箱发送验证码
          </button>
        </el-form-item>
      </el-row>
    </el-form>
    <el-dialog title='请输入验证码' :visible.sync='dialogVisible' width='30%' :destroy-on-close='true' :close-on-click-modal='false'>
      <el-input v-model='code' type='text' auto-complete='off' placeholder='验证码'>
      </el-input>
      <span slot='footer' class='dialog-footer'>
        <el-button @click='dialogVisible = false'>取 消</el-button>
        <el-button type='primary' @click='confirm()'>验 证</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
export default {
  props: {
    fromRegister: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    // 密码强度限制
    var passwordConfirm = (rule, value, callback) => {
      if (value) {
        var pass_flag = /[A-Z]/.test(value) && /[a-z]/.test(value) && /[0-9]/.test(value);
        if (pass_flag == false) {
          callback(new Error('密码需包含大小写字母、数字'));
        }
        callback();
      }
      callback(new Error('密码不能为空'));
    };
    return {
      registerForm: {
        role: 'student',
        username: '',
        password: '',
        password_again:'',
        email: '',
      },
      registerRules: {
        username: [
          { required: true, trigger: 'blur', message: '用户名不能为空' },
        ],
        password: [
          { required: true, trigger: 'blur', message: '密码不能为空' },
          { validator: passwordConfirm, trigger: 'change' },
        ],
        password_again:[
          { required: true, trigger: 'blur', message: '请重复输入密码' },
        ],
        email: [
          { required: true, trigger: 'blur', message: '邮箱不能为空' },
          {
            pattern: /^[a-zA-Z0-9]+@tongji.edu.cn$/,
            message: '请输入合法的同济邮箱',
            trigger: 'change',
          },
        ],
      },
      loading: false,
      dialogVisible: false,
      code: '',
    };
  },
  methods: {
    // 发送验证邮件
    send_email() {
      // 重复密码
      if(this.registerForm.password_again != this.registerForm.password){
        this.$message({
          message: '两次密码不一致，请重新输入',
          type: 'error',
        });
        return;
      }
      // 前端验证同济邮箱
      var reg = /^[a-zA-Z0-9]+@tongji.edu.cn$/;
      var email_flag = reg.test(this.registerForm.email);
      if (email_flag == false) {
        this.$message({
          message: '邮件格式错误，请重新输入！',
          type: 'error',
        });
        return;
      }
      // 前端密码强度
      var pass_flag = /[A-Z]/.test(this.registerForm.password) && /[a-z]/.test(this.registerForm.password) && /[0-9]/.test(this.registerForm.password);
      if (pass_flag == false) {
        this.$message({
          message: '密码需要包含大小写以及数字，请重新输入！',
          type: 'error',
        });
        return;
      }
      // 用户名验证
      if(this.registerForm.username == ''){
        this.$message({
          message: '用户名不能为空，请重新输入！',
          type: 'error',
        });
        return;
      }

      // 前后端交互
      // 发送邮件
      this.$axios({
        url: '/api/auth/send-emailcode',
        data: {
          email: this.registerForm.email,
        },
        method: 'post',
      })
        // 成功
        .then((result) => {
          //发送邮件成功
          if (result.data.code == 200) {
            // 显示输入验证码的对话框
            this.dialogVisible = true;
            this.$message({
              message: '邮件已发送，请查收！',
              type: 'success',
            });
            // // console.log(result.data);

          }
          else if (result.data.code == 400) {
            // 无效的邮箱格式/
            this.$message({
              message: result.data.msg,
              type: 'error',
            });
          }
          else if (result.data.code == 500) {
            // 服务器错误
            this.$message({
              message: '服务器错误',
              type: 'error',
            });
          }
          else {
            // console.log(result.data);
          }
          // console.log(result.data);
          // console.log(result.data.msg);
        })
        // 调用失败
        .catch(function (error) {
          // console.log(error);
        });
    },

    // 验证码确认
    confirm() {
      var add_flag = false;
      // 比较验证码
      this.$axios({
        url: '/api/auth/check-emailcode',
        params: {
          email: this.registerForm.email,
          emailcode: this.code
        },
        method: 'get',
      })
        // 成功
        .then((result) => {
          // 验证成功
          if (result.data.code == 200) {
            // var sp_place = this.registerForm.email.indexOf('@');
            // var temp = this.registerForm.email.substring(0, sp_place);
            add_flag = true;
            // 向数据库添加用户

          }
          else if (result.data.code == 400) {
            // 验证码错误
            this.$message({
              message: '验证码错误，请重试',
              type: 'error',
            });
          }
          else if (result.data.code == 500) {
            // 验证码过期
            this.$message({
              message: '验证码过期，请重新发送',
              type: 'error',
            });
          }
          else {
            // console.log(result.data);
          }
        })
        // 调用失败
        .catch(function (error) {
          // console.log(error);
        });
      if (add_flag)
      { 
        this.$axios({
          url: '/api/auth/user',
          data: {
            account:'',
            password: this.registerForm.password,
            email: this.registerForm.email,
            name: this.registerForm.username,
            role:this.registerForm.role,
            grade: '',
            gender:'',
            year:'',
            date: '',
            region: '',
            desc: '',
            avatar: 'http://localhost:3000/images/avatar.jpg',
            courses: []
          },
          method: 'post',
        })
          // 添加成功
          .then((result) => {
            if (result.data.code == 200) {
              this.dialogVisible = false;
              this.$message({
                message: '注册成功，请登录',
                type: 'success',
              });
              // console.log(result.data);
              // 返回登录页面
              this.$emit('fromRegister', true);
            }
            else if (result.data.code == 400) {
              // 用户已存在
              this.$message({
                message: '用户已存在，请登录！',
                type: 'error',
              });
            }
            else {
              // console.log(result.data);
            }
            // console.log(result.data);
            // console.log(result.data.msg);
          })
          // 调用失败
          .catch(function (error) {
            // console.log(error);
          });
      }
    },

    // debug
    confirm_test() {
      var sp_place = this.registerForm.email.indexOf('@');
      var temp = this.registerForm.email.substring(0, sp_place);
      // 向数据库添加用户
      this.$axios({
        url: '/api/auth/user',
        data: {
          account: temp, //学号
          password: this.$md5(this.registerForm.password),
          email: this.registerForm.email,
          username: '',
          major: '',
          grade: '',
          description: '',
        },
        method: 'post',
      })
        // 添加成功
        .then((result) => {
          if (result.data.code == 200) {
            this.dialogVisible = false;
            this.$message({
              message: '注册成功，请登录',
              type: 'success',
            });
            // console.log(result.data);
            // 返回登录页面
            this.$emit('fromRegister', true);
          }
          else if (result.data.code == 400) {
            // 用户已存在
            this.$message({
              message: '用户已存在，请登录！',
              type: 'error',
            });
          }
          else {
            // console.log(result.data);
          }
          // console.log(result.data);
          // console.log(result.data.msg);
        })
        // 调用失败
        .catch(function (error) {
          // console.log(error);
        });
    }
  },
  created() { },
  //document getElementByld('div_reg').clientWidth;
};
</script>

<style lang='scss' scoped>
.register-wrapper {
  width: 90%;
  height: 100%;
  background-color: rgba(255, 255, 255, 0);
  margin: 0 auto;
  //margin-top: 0;
  padding: 5%;
}

.register-form {
  margin: 0 auto;
  width: 100%;
  height: 100%;
  background: #ffffff00;
  justify-content: center;
  align-items: center;
}

.btn-register {
  display: inline-block;
  line-height: 1;
  white-space: nowrap;
  background-image: linear-gradient(90deg,
      rgb(114, 135, 254),
      rgb(130, 88, 186));
  border: 1px solid rgb(114, 135, 254);
  color: #ffffff;
  width: 100%;
  text-align: center;
  box-sizing: border-box;
  outline: 0;
  margin: 0;
  -webkit-box-sizing: border-box;
  -webkit-appearance: none;
  -webkit-transition: 0.1s;
  transition: 0.1s;
  font-weight: 500;
  padding: 12px 20px;
  font-size: 14px;
  border-radius: 4px;
}

.btn-register:focus,
.btn-register:hover {
  color: #ffffff;
  border-color: rgb(131, 150, 254);
  background-image: linear-gradient(90deg,
      rgb(131, 150, 254),
      rgb(158, 121, 205));
}

.btn-register:active {
  color: #ffffff;
  border-color: rgb(114, 135, 250);
  background-image: linear-gradient(90deg,
      rgb(114, 135, 250),
      rgb(106, 62, 164));
  outline: 0;
}

/deep/ .el-select .el-input {
  width: 90px;
  margin:0;
  padding:0;
}

.el-form-item{
  margin-bottom: 5%;
  //height: 15%;
  display: block;
  //position: relative;
}

// /deep/ .el-form-item__content{
//   height: 50%;
//   //background-color: rgb(19, 190, 47);
// }
// //deep inputinner height 百分比调不动
/deep/  .el-input__inner {
  //height: 230px;
  display: block;
  //background-color: rgb(25, 19, 190);
}
/deep/ .el-form-item__error {
  color: #F56C6C;
  font-size: 1px;
  line-height: 1;
  padding-top: 0px;
  position: absolute;
  top: 100%;
  left: 0;
}

</style>